<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): appPageRank.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_ff4b04dd53616468f2d812c0c78deef9.html">app</a></li><li class="navelem"><a class="el" href="dir_7c44b8ffe98d1c2c1ca6f015af6e79bb.html">appPageRank</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">appPageRank.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="appPageRank_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef APPPAGERANK_HPP_</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define APPPAGERANK_HPP_</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> * INCLUDES</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglApiVertex_8hpp.html">tiglApiVertex.hpp</a>&quot;</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglApiMessage_8hpp.html">tiglApiMessage.hpp</a>&quot;</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglApiCombiner_8hpp.html">tiglApiCombiner.hpp</a>&quot;</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="comment"> * GLOBAL DEFINITIONS</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="comment"> * PageRankVertex class</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType = <span class="keywordtype">char</span>&gt;</div>
<div class="line"><a name="l00078"></a><span class="lineno"><a class="line" href="classPageRankVertex.html">   78</a></span>&#160;<span class="keyword">class </span><a class="code" href="classPageRankVertex.html">PageRankVertex</a>:</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;      <span class="keyword">public</span> <a class="code" href="classTIGLApiVertex.html">TIGLApiVertex</a>&lt;DataType, double, TIGLContainersEdgeBase&lt;uint_fast32_t&gt;, uint_fast32_t, uint_fast32_t, DblMessage&gt;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;{</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classTIGLApiVertex.html">TIGLApiVertex&lt;DataType, double, TIGLContainersEdgeBase&lt;uint_fast32_t&gt;</a>, uint_fast32_t, uint_fast32_t, <a class="code" href="classTIGLApiMessage.html">DblMessage</a>&gt;::MESSAGE_BUF_TYPE MESSAGE_BUF_TYPE;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classTIGLApiVertex.html">TIGLApiVertex&lt;DataType, double, TIGLContainersEdgeBase&lt;uint_fast32_t&gt;</a>, uint_fast32_t, uint_fast32_t, <a class="code" href="classTIGLApiMessage.html">DblMessage</a>&gt;::OUT_EDGE_ITERATOR OUT_EDGE_ITERATOR;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="comment">    * Attributes</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00092"></a><span class="lineno"><a class="line" href="classPageRankVertex.html#a34843c26de6abc929d7583aac0a37512">   92</a></span>&#160;   <span class="keyword">static</span> uint_fast32_t <a class="code" href="classPageRankVertex.html#a34843c26de6abc929d7583aac0a37512">numVertices</a>;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="comment">    * constructor/destructor</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00107"></a><span class="lineno"><a class="line" href="classPageRankVertex.html#a59ab2141bb344a06dfed89ce5e4f9d1d">  107</a></span>&#160;   <a class="code" href="classPageRankVertex.html#a59ab2141bb344a06dfed89ce5e4f9d1d">PageRankVertex</a>(uint_fast32_t key) :</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;         <a class="code" href="classTIGLApiVertex.html">TIGLApiVertex</a>&lt;char, double, <a class="code" href="classTIGLContainersEdgeBase.html">TIGLContainersEdgeBase</a>&lt;uint_fast32_t&gt;, uint_fast32_t, uint_fast32_t, <a class="code" href="classTIGLApiMessage.html">DblMessage</a>&gt;(key, true, false)</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;   {</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;   }</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00117"></a><span class="lineno"><a class="line" href="classPageRankVertex.html#a1cc3fb8982a74e26655420bd6ef40c38">  117</a></span>&#160;   <a class="code" href="classPageRankVertex.html#a1cc3fb8982a74e26655420bd6ef40c38">~PageRankVertex</a>()</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;   {</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;   }</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="comment">    * public Methods</span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ALLOCATOR_TYPE&gt;</div>
<div class="line"><a name="l00138"></a><span class="lineno"><a class="line" href="classPageRankVertex.html#a5efbbc3acedbe1f3a98651f231d7830a">  138</a></span>&#160;   uint_fast32_t <a class="code" href="classPageRankVertex.html#a5efbbc3acedbe1f3a98651f231d7830a">compute</a>(MESSAGE_BUF_TYPE *pIn, vector&lt;DblMessage, ALLOCATOR_TYPE&gt; *pOut, uint_fast32_t numMessages)</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;   {</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;      <span class="keywordtype">double</span> newRank = 0.0;</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;      <span class="keywordflow">if</span> (numMessages &gt; 1)</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;         cout &lt;&lt; <span class="stringliteral">&quot;!!! Warning PageRankVertex compute: numMessages(&quot;</span> &lt;&lt; this-&gt;getId() &lt;&lt; <span class="stringliteral">&quot;) = &quot;</span> &lt;&lt; numMessages &lt;&lt; endl;</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;      <span class="keywordflow">if</span> (numMessages &gt; pIn-&gt;size())</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;         cout &lt;&lt; <span class="stringliteral">&quot;!!! Warning PageRankVertex compute: numMessages is bigger than buffer size&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;      vector&lt;DblMessage&gt;::iterator itm = pIn-&gt;begin();</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;      <span class="keywordflow">for</span> (uint_fast32_t loopCount = 0; loopCount &lt; numMessages; loopCount++)</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;      {</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;         newRank += itm-&gt;getContent();</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;         ++itm;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;      }</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;      newRank = newRank * 0.85 + 0.15 / (double) numVertices;</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;      this-&gt;algData = newRank;</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;      uint_fast32_t numOutMessages = 0;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;      <span class="keywordtype">double</span> messageVal = (this-&gt;algData) / (<span class="keywordtype">double</span>) (this-&gt;getNumOutEdges());</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;      <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR ite = this-&gt;getBeginOutEdgeIterator(); ite != this-&gt;getEndOutEdgeIterator(); ++ite)</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;      {</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;         uint_fast32_t dst = ite-&gt;getNbr();</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;         <span class="keywordflow">if</span> (dst == this-&gt;<span class="keywordtype">id</span>)</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;            <span class="keywordflow">continue</span>;   <span class="comment">// ignoring self reference</span></div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;         <a class="code" href="classTIGLApiMessage.html">DblMessage</a> newMessage(this-&gt;<span class="keywordtype">id</span>, dst, messageVal);</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;         pOut-&gt;push_back(newMessage);</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;         numOutMessages++;</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;      }</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;      <span class="comment">//this-&gt;flagActive = true;</span></div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;      <span class="keywordflow">return</span> numOutMessages;</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;   }</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ALLOCATOR_TYPE&gt;</div>
<div class="line"><a name="l00187"></a><span class="lineno"><a class="line" href="classPageRankVertex.html#a99197c4b8e957ebc36a9ea4ea197f2ad">  187</a></span>&#160;   uint_fast32_t <a class="code" href="classPageRankVertex.html#a99197c4b8e957ebc36a9ea4ea197f2ad">init</a>(uint_fast32_t *pNumVertices, vector&lt;DblMessage, ALLOCATOR_TYPE&gt; *pOut)</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;   {</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;      numVertices = *pNumVertices;</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;      this-&gt;algData = 1.0 / numVertices;</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;      <span class="keywordtype">double</span> messageVal = (this-&gt;algData) / (<span class="keywordtype">double</span>) (this-&gt;getNumOutEdges());</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;      uint_fast32_t numOutMessages = 0;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;      <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR ite = this-&gt;getBeginOutEdgeIterator(); ite != this-&gt;getEndOutEdgeIterator(); ++ite)</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;      {</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;         uint_fast32_t dst = ite-&gt;getNbr();</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;         <span class="keywordflow">if</span> (dst == this-&gt;<span class="keywordtype">id</span>)</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;            <span class="keywordflow">continue</span>;   <span class="comment">// ignoring self reference</span></div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;         <a class="code" href="classTIGLApiMessage.html">DblMessage</a> newMessage(this-&gt;<span class="keywordtype">id</span>, dst, messageVal);</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;         pOut-&gt;push_back(newMessage);</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;         numOutMessages++;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;      }</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;      this-&gt;flagActive = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;      <span class="keywordflow">return</span> numOutMessages;</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;   }</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;};</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType&gt;</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;uint_fast32_t <a class="code" href="classPageRankVertex.html">PageRankVertex&lt;DataType&gt;::numVertices</a>;</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;<span class="comment"> * PageRankCombiner class</span></div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00226"></a><span class="lineno"><a class="line" href="classPageRankCombiner.html">  226</a></span>&#160;<span class="keyword">class </span><a class="code" href="classPageRankCombiner.html">PageRankCombiner</a>: <span class="keyword">public</span> <a class="code" href="classTIGLApiCombiner.html">TIGLApiCombiner</a>&lt;DblMessage&gt;</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;{</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> vector&lt;DblMessage&gt;::iterator MESSAGE_ITERATOR;</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;   <a class="code" href="classPageRankCombiner.html">PageRankCombiner</a>()</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;   {</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;   }</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;   ~<a class="code" href="classPageRankCombiner.html">PageRankCombiner</a>()</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;   {</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;   }</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;<span class="comment">    * class methods</span></div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00254"></a><span class="lineno"><a class="line" href="classPageRankCombiner.html#a8ec69e5445b6072b2689a2eaa34f0c3b">  254</a></span>&#160;   <span class="keyword">inline</span> uint_fast32_t <a class="code" href="classPageRankCombiner.html#a8ec69e5445b6072b2689a2eaa34f0c3b">combineMessages</a>(MESSAGE_ITERATOR itIn, uint_fast32_t numMessages, MESSAGE_ITERATOR itOut)</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;   {</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;      <span class="keywordflow">return</span> this-&gt;sumCombineMessages(itIn, numMessages, itOut);</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;   }</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00267"></a><span class="lineno"><a class="line" href="classPageRankCombiner.html#affcd0be8d4296215db2db4b03f77b5f0">  267</a></span>&#160;   <span class="keyword">inline</span> uint_fast32_t <a class="code" href="classPageRankCombiner.html#affcd0be8d4296215db2db4b03f77b5f0">combineMessages</a>(<a class="code" href="classTIGLApiMessage.html">DblMessage</a> &amp; newMessage, MESSAGE_ITERATOR itOut)</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;   {</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;      <span class="keywordflow">return</span> this-&gt;sumCombineMessages(newMessage, itOut);</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;   }</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;};</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* APPPAGERANK_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classPageRankVertex_html_a5efbbc3acedbe1f3a98651f231d7830a"><div class="ttname"><a href="classPageRankVertex.html#a5efbbc3acedbe1f3a98651f231d7830a">PageRankVertex::compute</a></div><div class="ttdeci">uint_fast32_t compute(MESSAGE_BUF_TYPE *pIn, vector&lt; DblMessage, ALLOCATOR_TYPE &gt; *pOut, uint_fast32_t numMessages)</div><div class="ttdoc">customized compute function </div><div class="ttdef"><b>Definition:</b> appPageRank.hpp:138</div></div>
<div class="ttc" id="classPageRankCombiner_html_affcd0be8d4296215db2db4b03f77b5f0"><div class="ttname"><a href="classPageRankCombiner.html#affcd0be8d4296215db2db4b03f77b5f0">PageRankCombiner::combineMessages</a></div><div class="ttdeci">uint_fast32_t combineMessages(DblMessage &amp;newMessage, MESSAGE_ITERATOR itOut)</div><div class="ttdoc">overloaded customized combine function that combines a single message </div><div class="ttdef"><b>Definition:</b> appPageRank.hpp:267</div></div>
<div class="ttc" id="classTIGLContainersEdgeBase_html"><div class="ttname"><a href="classTIGLContainersEdgeBase.html">TIGLContainersEdgeBase</a></div><div class="ttdoc">Core edge class. </div><div class="ttdef"><b>Definition:</b> tiglContainersEdgeBase.hpp:66</div></div>
<div class="ttc" id="classPageRankVertex_html_a99197c4b8e957ebc36a9ea4ea197f2ad"><div class="ttname"><a href="classPageRankVertex.html#a99197c4b8e957ebc36a9ea4ea197f2ad">PageRankVertex::init</a></div><div class="ttdeci">uint_fast32_t init(uint_fast32_t *pNumVertices, vector&lt; DblMessage, ALLOCATOR_TYPE &gt; *pOut)</div><div class="ttdoc">customized init function </div><div class="ttdef"><b>Definition:</b> appPageRank.hpp:187</div></div>
<div class="ttc" id="classPageRankCombiner_html"><div class="ttname"><a href="classPageRankCombiner.html">PageRankCombiner</a></div><div class="ttdoc">Combiner class for the Page Rank algorithm. </div><div class="ttdef"><b>Definition:</b> appPageRank.hpp:226</div></div>
<div class="ttc" id="classPageRankVertex_html"><div class="ttname"><a href="classPageRankVertex.html">PageRankVertex</a></div><div class="ttdoc">Customized class for the Page Rank algorithm. </div><div class="ttdef"><b>Definition:</b> appPageRank.hpp:78</div></div>
<div class="ttc" id="classPageRankVertex_html_a34843c26de6abc929d7583aac0a37512"><div class="ttname"><a href="classPageRankVertex.html#a34843c26de6abc929d7583aac0a37512">PageRankVertex::numVertices</a></div><div class="ttdeci">static uint_fast32_t numVertices</div><div class="ttdoc">numVertices: a static member that holds the total number of vertices </div><div class="ttdef"><b>Definition:</b> appPageRank.hpp:92</div></div>
<div class="ttc" id="classPageRankVertex_html_a1cc3fb8982a74e26655420bd6ef40c38"><div class="ttname"><a href="classPageRankVertex.html#a1cc3fb8982a74e26655420bd6ef40c38">PageRankVertex::~PageRankVertex</a></div><div class="ttdeci">~PageRankVertex()</div><div class="ttdoc">destructor </div><div class="ttdef"><b>Definition:</b> appPageRank.hpp:117</div></div>
<div class="ttc" id="classPageRankCombiner_html_a8ec69e5445b6072b2689a2eaa34f0c3b"><div class="ttname"><a href="classPageRankCombiner.html#a8ec69e5445b6072b2689a2eaa34f0c3b">PageRankCombiner::combineMessages</a></div><div class="ttdeci">uint_fast32_t combineMessages(MESSAGE_ITERATOR itIn, uint_fast32_t numMessages, MESSAGE_ITERATOR itOut)</div><div class="ttdoc">customized combine function the combines a set of messages that calls the generic sum combine ...</div><div class="ttdef"><b>Definition:</b> appPageRank.hpp:254</div></div>
<div class="ttc" id="classTIGLApiMessage_html"><div class="ttname"><a href="classTIGLApiMessage.html">TIGLApiMessage</a></div><div class="ttdoc">Core data message class definition. </div><div class="ttdef"><b>Definition:</b> tiglApiMessage.hpp:66</div></div>
<div class="ttc" id="tiglApiCombiner_8hpp_html"><div class="ttname"><a href="tiglApiCombiner_8hpp.html">tiglApiCombiner.hpp</a></div></div>
<div class="ttc" id="classTIGLApiVertex_html"><div class="ttname"><a href="classTIGLApiVertex.html">TIGLApiVertex</a></div><div class="ttdoc">Core vertex class for the TIGL Engine (with only output edge buffer). </div><div class="ttdef"><b>Definition:</b> tiglApiVertex.hpp:83</div></div>
<div class="ttc" id="classPageRankVertex_html_a59ab2141bb344a06dfed89ce5e4f9d1d"><div class="ttname"><a href="classPageRankVertex.html#a59ab2141bb344a06dfed89ce5e4f9d1d">PageRankVertex::PageRankVertex</a></div><div class="ttdeci">PageRankVertex(uint_fast32_t key)</div><div class="ttdoc">constructor enable vertex processing even in the absence of messages </div><div class="ttdef"><b>Definition:</b> appPageRank.hpp:107</div></div>
<div class="ttc" id="classTIGLApiCombiner_html"><div class="ttname"><a href="classTIGLApiCombiner.html">TIGLApiCombiner</a></div><div class="ttdoc">Pure combiner class for the TIGL engine. </div><div class="ttdef"><b>Definition:</b> tiglApiCombiner.hpp:66</div></div>
<div class="ttc" id="tiglApiVertex_8hpp_html"><div class="ttname"><a href="tiglApiVertex_8hpp.html">tiglApiVertex.hpp</a></div></div>
<div class="ttc" id="tiglApiMessage_8hpp_html"><div class="ttname"><a href="tiglApiMessage_8hpp.html">tiglApiMessage.hpp</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:51 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
